<!-- Example widget for demonstration  -->
<script async script lang="ts">
	import { websiteApi } from '$lib/requests/requests';
	import { onMount } from 'svelte';
	import ReconnectingWebSocket from 'reconnecting-websocket';

	// This URI should work : http://localhost:5173/time-to-start
	let end: Date;

	let now: Date = new Date();
	let days: number[];
	let hours: number[];
	let minutes: number[];
	let seconds: number[];

	let formatter = new Intl.NumberFormat('fr-FR', {
		minimumIntegerDigits: 2
	});
	onMount(async () => {
		try {
			let resp = await websiteApi().getStartDateWebsiteDatesStartGet();
			end = new Date(resp.data.start_date);
			dateDiff(end, now);
		} catch {
			// Redirect to 404
			// window.location.href = '/404';
		}

		setInterval(computeDate, 1000);
	});

	function computeDate() {
		now = new Date();
		dateDiff(end, now);
	}
	function formatNumber(n: number): number[] {
		let str = formatter.format(n);
		let arr = str.split('');
		let newTarget = [];
		for (let i = 0; i < arr.length; i++) {
			if (arr[i] === ',') {
				newTarget.push(10);
			} else {
				newTarget.push(+arr[i]);
			}
		}
		return newTarget;
	}
	function dateDiff(date1: Date, date2: Date) {
		const diff = date1.getTime() - date2.getTime();
		days = formatNumber(Math.floor(diff / (1000 * 60 * 60 * 24)));
		const restDays = diff % (1000 * 60 * 60 * 24);
		hours = formatNumber(Math.floor(restDays / (1000 * 60 * 60)));
		const restHours = restDays % (1000 * 60 * 60);
		minutes = formatNumber(Math.floor(restHours / (1000 * 60)));
		const restMinutes = restHours % (1000 * 60);
		seconds = formatNumber(Math.floor(restMinutes / 1000));

		return diff;
	}
</script>

<div class="p-4 flex flex-col justify-center items-center">
	<h1 class="text-6xl red-hat flex">
		{#each minutes ?? [] as digit}
			<span class="smart-countdown font-mono mt-1">
				<span style="--value:{digit};"></span>
			</span>
		{/each}
		<div class="fredoka">{minutes ? 'min ' : ''}</div>
		{#each seconds ?? [] as digit}
			<span class="smart-countdown font-mono mt-1">
				<span style="--value:{digit};"></span>
			</span>
		{/each}
		<div class="fredoka">{seconds ? 's' : ''}</div>
	</h1>
</div>

<style>
	@import url('https://fonts.googleapis.com/css2?family=Red+Hat+Mono:wght@700&display=swap');
	@import url('https://fonts.googleapis.com/css2?family=Fredoka:wght@300..700&display=swap');
	.red-hat {
		font-family: 'Red Hat Mono', monospace;
		font-optical-sizing: auto;
		font-weight: 700;
		font-style: normal;
	}
	.fredoka {
		font-family: 'Fredoka', sans-serif;
		font-optical-sizing: auto;
		font-weight: 500;
		font-style: normal;
		font-variation-settings: 'wdth' 100;
		margin: 0 1rem;
	}

	h1 {
		color: white;
	}
	.smart-countdown {
		line-height: 1em;
	}
	.smart-countdown {
		display: inline-flex;
	}
	.smart-countdown > * {
		height: 1em;
		display: inline-block;
		overflow-y: hidden;
	}
	.smart-countdown > *:before {
		position: relative;
		content: '0\A 1\A 2\A 3\A 4\A 5\A 6\A 7\A 8\A 9\A ,\A';
		white-space: pre;
		top: calc(var(--value) * -1em);
		text-align: center;
		transition: all 1s cubic-bezier(1, 0, 0, 1);
	}
</style>
